(* error.sml
 *
 *)

structure Error = 
    struct

        exception Abort

        (* abort -- normal quit upon an error *)
        fun report l = (app print ("ERROR -- "::l); print "\n")
        fun abort l = (report l; raise Abort)

        (* fail -- abnormal failure *)
        fun fail [] = raise Fail ""
          | fail (x::xs) = raise Fail (concat (xs@[" [function ",x,"]"]))

        (* warning -- something to be aware of, but can be handled *)
        fun warning l = (app print ("WARNING -- "::l); print "\n")

        (* implementation warning -- a warning issued by an implementation-specific
         * feature *)
        fun imp l = (app print ("IMPLEMENTATION WARNING -- "::l); print "\n")

        (* reporting of an exception, before dying *)
        fun reportException (e) = report [exnMessage e]
          (* app (fn x => Error.report [x]) (SMLofNJ.exnHistory e)) *)



    end
