
(**********************************************************************
 *
 *  This file was automatically generated
 *  (Wed May 25 23:31:55 2005)
 *
 **********************************************************************)

signature SPEC_exp = sig
  type 'a t

  datatype 'a enc_boolexp = ENC_boolexp
  datatype 'a enc_intexp = ENC_intexp

  type 'a Aexp = 'a t
  type 'a Aboolexp = ('a enc_boolexp) t
  type 'a Aintexp = ('a enc_intexp) t

  type Cexp = unit t
  type Cboolexp = (unit enc_boolexp) t
  type Cintexp = (unit enc_intexp) t

  val Boolexp : bool -> Cexp
  val Andexp : 'a1 Aexp * 'a2 Aexp -> Cexp
  val Intexp : int -> Cexp
  val Plusexp : 'a1 Aexp * 'a2 Aexp -> Cexp
  val Ifexp : 'a1 Aexp * 'a2 Aexp * 'a2 Aexp -> Cexp
  val Boolboolexp : bool -> Cboolexp
  val Andboolexp : 'a1 Aboolexp * 'a2 Aboolexp -> Cboolexp
  val Ifboolexp : 'a1 Aboolexp * 'a2 Aboolexp * 'a2 Aboolexp -> Cboolexp
  val Intintexp : int -> Cintexp
  val Plusintexp : 'a1 Aintexp * 'a2 Aintexp -> Cintexp
  val Ifintexp : 'a1 Aboolexp * 'a2 Aintexp * 'a2 Aintexp -> Cintexp

  val caseexp : 'a Aexp -> (bool -> 'b) * (Cexp * Cexp -> 'b) * (int -> 'b) * (Cexp * Cexp -> 'b) * (Cexp * Cexp * Cexp -> 'b) -> 'b
  val caseboolexp : 'a Aboolexp -> (bool -> 'b) * (Cboolexp * Cboolexp -> 'b) * (Cboolexp * Cboolexp * Cboolexp -> 'b) -> 'b
  val caseintexp : 'a Aintexp -> (int -> 'b) * (Cintexp * Cintexp -> 'b) * (Cboolexp * Cintexp * Cintexp -> 'b) -> 'b

  val coerceexp : 'a Aexp -> Cexp
  val coerceboolexp : 'a Aboolexp -> Cboolexp
  val coerceintexp : 'a Aintexp -> Cintexp

end

structure Spec_exp :> SPEC_exp = struct
  datatype exp = Bool of bool | And of exp * exp | Int of int | Plus of exp * exp | If of exp * exp * exp

  type 'a t = exp

  datatype 'a enc_boolexp = ENC_boolexp
  datatype 'a enc_intexp = ENC_intexp

  type 'a Aexp = 'a t
  type 'a Aboolexp = ('a enc_boolexp) t
  type 'a Aintexp = ('a enc_intexp) t

  type Cexp = unit t
  type Cboolexp = (unit enc_boolexp) t
  type Cintexp = (unit enc_intexp) t

  val Boolexp = Bool
  val Andexp = And
  val Intexp = Int
  val Plusexp = Plus
  val Ifexp = If
  val Boolboolexp = Bool
  val Andboolexp = And
  val Ifboolexp = If
  val Intintexp = Int
  val Plusintexp = Plus
  val Ifintexp = If

  fun fail _ = raise Match
  fun casef c (argBool,argAnd,argInt,argPlus,argIf) = case c of
         Bool(x) => argBool (x) | And(x) => argAnd (x) | Int(x) => argInt (x) | Plus(x) => argPlus (x) | If(x) => argIf (x)

 fun caseexp c (argBool,argAnd,argInt,argPlus,argIf) = casef c (argBool,argAnd,argInt,argPlus,argIf)
 fun caseboolexp c (argBool,argAnd,argIf) = casef c (argBool,argAnd,fail,fail,argIf)
 fun caseintexp c (argInt,argPlus,argIf) = casef c (fail,fail,argInt,argPlus,argIf)

  fun coercef v = v
  val coerceexp = coercef
  val coerceboolexp = coercef
  val coerceintexp = coercef
end
